/**
 * CD.java
 *
 * File generated from the medication::CD uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class CD.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CD", propOrder = {
	"originalText",
	"qualifier",
	"translation",
	"code",
	"codeSystem",
	"codeSystemName",
	"codeSystemVersion",
	"displayName"
})
@XmlRootElement(name = "CD")
public class CD extends net.ihe.gazelle.medication.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The text or phrase used as
	                                the basis for the coding.                      .
	 */
	@XmlElement(name = "originalText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ED originalText;
	/**
	 *                          Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                      .
	 */
	@XmlElement(name = "qualifier", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.CR> qualifier;
	/**
	 *                          A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                            .
	 */
	@XmlElement(name = "translation", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.CD> translation;
	/**
	 *                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        .
	 */
	@XmlAttribute(name = "code")
	public String code;
	/**
	 *                       Specifies the code system that
	                            defines the code.                   .
	 */
	@XmlAttribute(name = "codeSystem")
	public String codeSystem;
	/**
	 *                       A common name of the coding system.
	                        .
	 */
	@XmlAttribute(name = "codeSystemName")
	public String codeSystemName;
	/**
	 *                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        .
	 */
	@XmlAttribute(name = "codeSystemVersion")
	public String codeSystemVersion;
	/**
	 *                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   .
	 */
	@XmlAttribute(name = "displayName")
	public String displayName;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return originalText.
	 * @return originalText :                          The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                      
	 */
	public net.ihe.gazelle.medication.ED getOriginalText() {
	    return originalText;
	}
	
	/**
	 * Set a value to attribute originalText.
	 * @param originalText :                          The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                                               The text or phrase used as
	                                the basis for the coding.                      .
	 */
	public void setOriginalText(net.ihe.gazelle.medication.ED originalText) {
	    this.originalText = originalText;
	}
	
	
	
	
	/**
	 * Return qualifier.
	 * @return qualifier :                          Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                      
	 */
	public List<net.ihe.gazelle.medication.CR> getQualifier() {
		if (qualifier == null) {
	        qualifier = new ArrayList<net.ihe.gazelle.medication.CR>();
	    }
	    return qualifier;
	}
	
	/**
	 * Set a value to attribute qualifier.
	 * @param qualifier :                          Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                                               Specifies additional codes
	                                that increase the                         specificity of the primary
	                                code.                      .
	 */
	public void setQualifier(List<net.ihe.gazelle.medication.CR> qualifier) {
	    this.qualifier = qualifier;
	}
	
	
	
	/**
	 * Add a qualifier to the qualifier collection.
	 * @param qualifier_elt Element to add.
	 */
	public void addQualifier(net.ihe.gazelle.medication.CR qualifier_elt) {
	    this.qualifier.add(qualifier_elt);
	}
	
	/**
	 * Remove a qualifier to the qualifier collection.
	 * @param qualifier_elt Element to remove
	 */
	public void removeQualifier(net.ihe.gazelle.medication.CR qualifier_elt) {
	    this.qualifier.remove(qualifier_elt);
	}
	
	/**
	 * Return translation.
	 * @return translation :                          A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                            
	 */
	public List<net.ihe.gazelle.medication.CD> getTranslation() {
		if (translation == null) {
	        translation = new ArrayList<net.ihe.gazelle.medication.CD>();
	    }
	    return translation;
	}
	
	/**
	 * Set a value to attribute translation.
	 * @param translation :                          A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                                                     A set of other concept
	                                descriptors that translate                         this concept
	                                descriptor into other code systems.
	                            .
	 */
	public void setTranslation(List<net.ihe.gazelle.medication.CD> translation) {
	    this.translation = translation;
	}
	
	
	
	/**
	 * Add a translation to the translation collection.
	 * @param translation_elt Element to add.
	 */
	public void addTranslation(net.ihe.gazelle.medication.CD translation_elt) {
	    this.translation.add(translation_elt);
	}
	
	/**
	 * Remove a translation to the translation collection.
	 * @param translation_elt Element to remove
	 */
	public void removeTranslation(net.ihe.gazelle.medication.CD translation_elt) {
	    this.translation.remove(translation_elt);
	}
	
	/**
	 * Return code.
	 * @return code :                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        
	 */
	public String getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code :                       The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                                              The plain code symbol defined by the
	                            code system.                      For example, "784.0" is the code
	                            symbol of the ICD-9                      code "784.0" for headache.
	                        .
	 */
	public void setCode(String code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return codeSystem.
	 * @return codeSystem :                       Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                   
	 */
	public String getCodeSystem() {
	    return codeSystem;
	}
	
	/**
	 * Set a value to attribute codeSystem.
	 * @param codeSystem :                       Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                                         Specifies the code system that
	                            defines the code.                   .
	 */
	public void setCodeSystem(String codeSystem) {
	    this.codeSystem = codeSystem;
	}
	
	
	
	
	/**
	 * Return codeSystemName.
	 * @return codeSystemName :                       A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                        
	 */
	public String getCodeSystemName() {
	    return codeSystemName;
	}
	
	/**
	 * Set a value to attribute codeSystemName.
	 * @param codeSystemName :                       A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                                              A common name of the coding system.
	                        .
	 */
	public void setCodeSystemName(String codeSystemName) {
	    this.codeSystemName = codeSystemName;
	}
	
	
	
	
	/**
	 * Return codeSystemVersion.
	 * @return codeSystemVersion :                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        
	 */
	public String getCodeSystemVersion() {
	    return codeSystemVersion;
	}
	
	/**
	 * Set a value to attribute codeSystemVersion.
	 * @param codeSystemVersion :                       If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                                              If applicable, a version descriptor
	                            defined                      specifically for the given code system.
	                        .
	 */
	public void setCodeSystemVersion(String codeSystemVersion) {
	    this.codeSystemVersion = codeSystemVersion;
	}
	
	
	
	
	/**
	 * Return displayName.
	 * @return displayName :                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   
	 */
	public String getDisplayName() {
	    return displayName;
	}
	
	/**
	 * Set a value to attribute displayName.
	 * @param displayName :                       A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                                         A name or title for the code, under
	                            which the sending                      system shows the code value to
	                            its users.                   .
	 */
	public void setDisplayName(String displayName) {
	    this.displayName = displayName;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "CD").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(CD cD, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cD != null){
   			net.ihe.gazelle.medication.ANY.validateByModule(cD, location, cvm, diagnostic);
			net.ihe.gazelle.medication.ED.validateByModule(cD.getOriginalText(), location + "/originalText", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.CR qualifier: cD.getQualifier()){
					net.ihe.gazelle.medication.CR.validateByModule(qualifier, location + "/qualifier[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.CD translation: cD.getTranslation()){
					net.ihe.gazelle.medication.CD.validateByModule(translation, location + "/translation[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}